//---------------------------------------------------------------------------
#ifndef CpkKeyWins1H
#define CpkKeyWins1H
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\ExtCtrls.hpp>
#include "explbtn.hpp"
#include <vcl\Menus.hpp>

#include "PGPbuffers.h"
//---------------------------------------------------------------------------
class TCpkKeyList1 : public TPGPkeylist
{
public:
   int shrtLen;
   int addrLen;
   TStringList *shorts;
   virtual __fastcall TCpkKeyList1();
   virtual __fastcall TCpkKeyList1(AnsiString filename);
   virtual __fastcall TCpkKeyList1(TPGPbuffer *keys);
   virtual __fastcall TCpkKeyList1(TPGPkeylist *keys);
   virtual __fastcall TCpkKeyList1(TStrings *keys);
   virtual __fastcall~TCpkKeyList1();
   void __fastcall SaveToFileBak(AnsiString &docname, int bakcopies);
   virtual void __fastcall LoadFromFile(AnsiString filename);
   virtual int __fastcall AddKeys(TPGPbuffer *keys);
   virtual int __fastcall AddKeys(TPGPkeylist *keys);
   virtual int __fastcall AddKeys(TStrings *keys);
   virtual AnsiString __fastcall KeyDescription(int atPos);
   void __fastcall GetShorts(TStrings *longseqshorts);
   AnsiString __fastcall ShortName(int atPos);
   AnsiString __fastcall EAddress(int atPos);
   AnsiString __fastcall Algorithm(int atPos);
   AnsiString __fastcall IdText8(int atPos);
};

class TCpkKeyWin1 : public TForm
{
__published:	// IDE-managed Components
	TTreeView *TreeView;
	TPanel *Panel1;
	TBevel *Bevel5;
	TBevel *Bevel3;
	TBevel *Bevel2;
	TBevel *Bevel1;
	TOfficeButton *DeleteBtn;
	TOfficeButton *HelpBtn;
	TOfficeButton *OkBtn;
	TOfficeButton *ImportBtn;
	TOfficeButton *SaveBtn;
	TOfficeButton *DocsBtn;
	TOfficeButton *RefreshBtn;
	TOfficeButton *DisableBtn;
	TOfficeButton *RequestBtn;
	TOfficeButton *ClearAllBtn;
	TPopupMenu *PopupMenu;
	TMenuItem *PopDisableItem;
	TMenuItem *N1;
	TMenuItem *Clear1;
	TMenuItem *PopSaveItem;
	TMenuItem *PopRefreshItem;
	TMenuItem *PopImportItem;
	TMenuItem *N3;
	TMenuItem *PopDeleteItem;
	TPopupMenu *PopupMenu2;
	TMenuItem *PubringItem;
	TMenuItem *ListDocItem;
	TPopupMenu *PopupMenu1;
	TMenuItem *RemailerAlldocsItem;
	TMenuItem *N2;
	TMenuItem *RemailerConfigItem;
	TMenuItem *RemailerKeyItem;
	TMenuItem *RemailerHelpItem;
	TMenuItem *RemailerStatsItem;
	TTimer *Timer1;
	TTimer *FlashTimer;
	TImageList *ImageList2;
	TMenuItem *PopExpandItem;
	TMenuItem *PopCollapseItem;
	TMenuItem *N4;
	TOfficeButton *HideDisBtn;
	TImageList *ImageList1;
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall Timer1Timer(TObject *Sender);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall ClearAllBtnClick(TObject *Sender);
	void __fastcall TreeViewMouseDown(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y);
	void __fastcall DisableBtnClick(TObject *Sender);
	void __fastcall TreeViewChange(TObject *Sender, TTreeNode *Node);
	void __fastcall OkBtnClick(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall PopExpandItemClick(TObject *Sender);
	void __fastcall PopCollapseItemClick(TObject *Sender);
	void __fastcall SaveBtnClick(TObject *Sender);
	void __fastcall RefreshBtnClick(TObject *Sender);
	void __fastcall DeleteBtnClick(TObject *Sender);
	void __fastcall RemailerDocItemClick(TObject *Sender);
	void __fastcall HelpBtnClick(TObject *Sender);
	void __fastcall RemailerConfigItemClick(TObject *Sender);
	void __fastcall FormActivate(TObject *Sender);
	void __fastcall ImportBtnClick(TObject *Sender);
	void __fastcall HideDisBtnClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
    TList *keynodes;
    TCpkKeyList1 *keys;
    TStringList *newkeys,*diskeys;
    int curkey,asciiblks;
    AnsiString cap;
    Graphics::TBitmap *bmpHideDis,*bmpShowAll;
    bool modified,checksave,initdone,hidedisabled;
	__fastcall TCpkKeyWin1(TComponent* Owner);
 	virtual __fastcall ~TCpkKeyWin1();
    //TPGPbuffer* __fastcall GetKey(int atPos);
    TPGPbuffer* __fastcall NodeKey(int atPos);
    void __fastcall SetTreeItemBold(TTreeNode *ANode, bool Value, TTreeView *ATree);
    void __fastcall MakeMessage(TStrings *message, AnsiString &addrs, AnsiString &subject);
    void __fastcall EnableDisableBtn(bool enable);
    void __fastcall SetNothingSelected();
    void __fastcall SetHelpBtnPos();
    void __fastcall GenTreeView();
    void __fastcall SaveKeys();
    void __fastcall SetCount(bool clear=false);
    void __fastcall EnableKey(int atPos, bool enable);
    void __fastcall AddKeysImport(TCpkKeyList1 *newkeys);
    void __fastcall AddDupsImport(TCpkKeyList1 *dupkeys);
    void __fastcall GetDisables();
    void __fastcall ClearTree();
    void __fastcall LoadKeys();
  // message functions
   void virtual __fastcall WMSaveBtnClicked(TMessage& Msg);
   void virtual __fastcall WMRefreshBtnClicked(TMessage& Msg);
   void virtual __fastcall WMImportBtnClicked(TMessage& Msg);
   void virtual __fastcall WMDisableBtnClicked(TMessage& Msg);
   void virtual __fastcall WMDeleteBtnClicked(TMessage& Msg);
   void virtual __fastcall WMGetKeyringMenuDat(TMessage& Msg);
   // message map
   BEGIN_MESSAGE_MAP
   MESSAGE_HANDLER(WM_SAVEBTNCLICKED,TMessage,WMSaveBtnClicked)
   MESSAGE_HANDLER(WM_REFRESHBTNCLICKED,TMessage,WMRefreshBtnClicked)
   MESSAGE_HANDLER(WM_IMPORTBTNCLICKED,TMessage,WMImportBtnClicked)
   MESSAGE_HANDLER(WM_DISABLEBTNCLICKED,TMessage,WMDisableBtnClicked)
   MESSAGE_HANDLER(WM_DELETEBTNCLICKED,TMessage,WMDeleteBtnClicked)
   MESSAGE_HANDLER(WM_GETKEYRINGMENUDAT,TMessage,WMGetKeyringMenuDat)
   END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
extern TCpkKeyWin1 *CpkKeyWin1;
//---------------------------------------------------------------------------
#endif
