//---------------------------------------------------------------------------
#ifndef MixKeyWins2H
#define MixKeyWins2H
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include "explbtn.hpp"
#include <vcl\ComCtrls.hpp>
#include <vcl\Menus.hpp>
#include "KeyringWins.h"
//---------------------------------------------------------------------------
class TMixKey2 : public TCustomKey
{
public:
   __property AnsiString caps      = { read=Caps };
   __property AnsiString version   = { read=Version };

   virtual __fastcall TMixKey2();
   virtual __fastcall TMixKey2(TCustomKey *key);
   virtual __fastcall TMixKey2(TStrings *key, bool Enabled=true);
private:
   AnsiString __fastcall Version();
   AnsiString __fastcall Caps();
};

class TMixKeyList2 : public TCustomKeyList
{
public:
   TStringList *type2;
   virtual __fastcall TMixKeyList2();
   virtual __fastcall TMixKeyList2(AnsiString filename);
   virtual __fastcall TMixKeyList2(TCustomKeyList *keys);
   virtual __fastcall TMixKeyList2(TCustomKey *key);
   virtual __fastcall TMixKeyList2(TStrings *keys);
   virtual __fastcall~TMixKeyList2();
   void __fastcall LoadFromStrings(TStrings *keys);
   void __fastcall SaveToFileBak(AnsiString &docname, int bakcopies);
   bool __fastcall InType2(TMixKey2 *key, bool &enabled);
   AnsiString __fastcall KeyDescription(int atPos);
   int  __fastcall AddKeys(TCustomKeyList *keys);
   int  __fastcall AddKeys(TStrings *keys);
   bool __fastcall AddKey(TCustomKey *key);
   bool __fastcall AddKey(TStrings *key);
   TMixKey2* __fastcall Key(int atPos);
   void __fastcall GetType2();
};

class TMixKeyWin2 : public TCustomKeyWin
{
__published: // IDE-managed Components
	TMenuItem *mlisttxt1;
	TMenuItem *type2list1;
	TMenuItem *pubringmix1;
	void __fastcall HelpBtnClick(TObject *Sender);
	void __fastcall ImportBtnClick(TObject *Sender);
	void __fastcall RemailerDocItemClick(TObject *Sender);
private: // User declarations
public:	 // User declarations
    TMixKeyList2 *imports;
	virtual __fastcall TMixKeyWin2(TComponent* Owner);
	virtual __fastcall TMixKeyWin2(TComponent* Owner, TMixKeyList2 *Imports);
    virtual __fastcall~TMixKeyWin2();
    TMixKey2* __fastcall NodeKey(int atPos);
    void __fastcall AddKeysImport(TCustomKeyList *NewKeys);
    void __fastcall InitSpecial();
    void __fastcall LoadTreeView();
    void __fastcall SaveKeys();
    void __fastcall LoadKeys();
};
//---------------------------------------------------------------------------
extern TMixKeyWin2 *MixKeyWin2;
//---------------------------------------------------------------------------
#endif
