# ---------------------------------------------------------------------------
VERSION = BCB.01
# ---------------------------------------------------------------------------
!ifndef BCB
BCB = $(MAKEDIR)\..
!endif
# ---------------------------------------------------------------------------
PROJECT = SETUP.exe
OBJFILES = SETUP.obj SetupDlg.obj UninstDlg.obj DirBrow.obj WaitDlg.obj \
   MixmastDlg.obj Mixmaster.obj SetupVer.obj Console.obj HeadMan.obj FileMan.obj \
   Global.obj SetupMain.obj View.obj WipeDlgs.obj
RESFILES = Setup.res
RESDEPEN = $(RESFILES) SetupDlg.dfm UninstDlg.dfm DirBrow.dfm WaitDlg.dfm \
   MixmastDlg.dfm SetupMain.dfm View.dfm WipeDlgs.dfm
LIBFILES = zlib.LIB
DEFFILE = 
# ---------------------------------------------------------------------------
CFLAG1 = -Od -Hc -w -k -r- -y -v -vi- -c -a4 -b- -w-par -w-inl -Vx -Ve -x
CFLAG2 = -DNO_DB_ENCRYPT -I.;$(BCB)\include;$(BCB)\include\vcl;$(BCB)\lib\misc \
   -H=$(BCB)\lib\vcld.csm 
PFLAGS = -AWinTypes=Windows;WinProcs=Windows;DbiTypes=BDE;DbiProcs=BDE;DbiErrs=BDE \
   -DNO_DB_ENCRYPT -U.;$(BCB)\lib\obj;$(BCB)\lib;$(BCB)\lib\misc \
   -I.;$(BCB)\include;$(BCB)\include\vcl;$(BCB)\lib\misc -v -$Y -$W -$O- -JPHNV \
   -M     
RFLAGS = -DNO_DB_ENCRYPT -i.;$(BCB)\include;$(BCB)\include\vcl;$(BCB)\lib\misc 
LFLAGS = -L.;$(BCB)\lib\obj;$(BCB)\lib;$(BCB)\lib\misc -aa -Tpe -x -v -V4.0 
IFLAGS = 
LINKER = ilink32
# ---------------------------------------------------------------------------
ALLOBJ = c0w32.obj $(OBJFILES)
ALLRES = $(RESFILES)
ALLLIB = $(LIBFILES) vcl.lib import32.lib cp32mt.lib 
# ---------------------------------------------------------------------------
.autodepend

$(PROJECT): $(OBJFILES) $(RESDEPEN) $(DEFFILE)
    $(BCB)\BIN\$(LINKER) @&&!
    $(LFLAGS) +
    $(ALLOBJ), +
    $(PROJECT),, +
    $(ALLLIB), +
    $(DEFFILE), +
    $(ALLRES) 
!

.pas.hpp:
    $(BCB)\BIN\dcc32 $(PFLAGS) { $** }

.pas.obj:
    $(BCB)\BIN\dcc32 $(PFLAGS) { $** }

.cpp.obj:
    $(BCB)\BIN\bcc32 $(CFLAG1) $(CFLAG2) -o$* $* 

.c.obj:
    $(BCB)\BIN\bcc32 $(CFLAG1) $(CFLAG2) -o$* $**

.rc.res:
    $(BCB)\BIN\brcc32 $(RFLAGS) $<
#-----------------------------------------------------------------------------
